#!perl
#-----Remove unwanted seqs from fasta file
system ('cls');

print "\n\n*******************************************************
This script splits sequences out of a fasta file based on names in a text file.\n
Brian Oakley
b.b.c.oakley at warwick.ac.uk
*******************************************************

\n\nFirst, enter name of fasta file:  ";

#---Read in subject file---
$subject_file=<STDIN>;
open (SUBJECT, $subject_file) or die "\nProblem with input file. Please try again.\n";
@data=<SUBJECT>;
$test = "@data";
@subjects = split(/>/, $test);
shift @subjects;

print "\nSubject file contains ",scalar@subjects," sequences\n"; 

#---Read in query file----
print "\n\nNow, enter name of query file (*.txt):  ";
$query_file=<STDIN>;
open (QUERY, $query_file) or die "\nInput \"file unwanted_sequence_names.txt\" file is missing. Please try again.\n";
chomp (@query_names=<QUERY>);
my %seen=();
        foreach $line(@query_names) {
        chomp $line;
        if ($line =~ m/[\d]|[\w]/) {
	push(@uniq_names,$line) unless $seen{$line}++;
        }
        }

print "\nQuery file contains ",scalar@query_names," names, of which ",scalar@uniq_names," are unique\n\n";

#---Open output files-----------
open (OUT, ">matched_sequences.fas") or die "\nOutput file cannot be opened. Please try again.\n";
open (OUT1, ">unmatched_sequences.fas") or die "\nOutput file cannot be opened. Please try again.\n";

#---Compare two lists----------
my $query_counter=-1;
foreach $query(@uniq_names) {
                $found_counter=0;
                $query_counter++;
		$match_counter=-1;
                foreach $entry (@subjects) {
                $match_counter++;
                  if ($entry =~ m/$query/)  {
                  push (@matched_seqs,$entry);
                  splice (@subjects,$match_counter,1);
                  $found_counter++;
                  }
                }

                #---print warning if any discrepancies---
                if ($found_counter==0||$found_counter>1) {
                #--only print once:---
                $error_counter+=1;
                if ($error_counter==1)  {
                print "\n \t  --- WARNINGS: --- \n\n Query sequence    Number of matches\n  -------------      -------------\n";
                 }
                #---print for each error:---
                print " $query\t\t\t$found_counter\n";
	        }
}

#-----Print outputs-----------
foreach $entry (@matched_seqs) {		
	print OUT (">$entry\n");
}

foreach $entry (@subjects) {		
	print OUT1 (">$entry\n");
}

print "\n\nFound ",scalar@matched_seqs,"/",scalar@uniq_names," sequences - written to 'matched_seqs.fas'\n\n";
print "Remaining ",scalar@subjects," sequences written to 'unmatched_seqs.fas'\n\n"; 

close OUT;
close OUT1;
end;
